VERSION 5.00
Begin VB.UserControl NmFileTypeRegister 
   CanGetFocus     =   0   'False
   ClientHeight    =   624
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   708
   InvisibleAtRuntime=   -1  'True
   PropertyPages   =   "NmFileTypeReg.ctx":0000
   ScaleHeight     =   624
   ScaleWidth      =   708
   ToolboxBitmap   =   "NmFileTypeReg.ctx":0013
   Begin VB.Image mIM 
      Height          =   384
      Left            =   72
      Picture         =   "NmFileTypeReg.ctx":0325
      Top             =   72
      Width           =   384
   End
End
Attribute VB_Name = "NmFileTypeRegister"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Perc As String
Private AcroDIR As String

Private Type mnuCommands
    Captions As New Collection
    Commands As New Collection
End Type

Private Type filetype
    Commands As mnuCommands
    Extension As String
    ProperName As String
    FullName As String
    ContentType As String
    IconPath As String
    IconIndex As Integer
End Type

Private Const REG_SZ = 1
Private Const HKEY_CLASSES_ROOT = &H80000000

Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegCreateKey Lib "advapi32" Alias "RegCreateKeyA" (ByVal _
hKey As Long, ByVal lpszSubKey As String, phkResult As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpszValueName As String, ByVal dwReserved As Long, ByVal fdwType As Long, lpbData As Any, ByVal cbData As Long) As Long


Private Const BIF_RETURNONLYFSDIRS = 1
Private Const BIF_DONTGOBELOWDOMAIN = 2
Private Const MAX_PATH = 260

Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long

Private Type BrowseInfo
   hWndOwner As Long
   pIDLRoot As Long
   pszDisplayName As Long
   lpszTitle As Long
   ulFlags As Long
   lpfnCallback As Long
   lParam As Long
   iImage As Long
End Type

'Valori predefiniti propriet:
Const m_def_FileContentType = "SomeMIMEtype"
Const m_def_FileExtension = ""
Const m_def_ExtShortDescription = ""
Const m_def_ExtFullDescription = ""
Const m_def_ApplicationToRun = ""
Const m_def_ApplicationIconIndex = 0
'Variabili propriet:
Dim m_FileContentType As String
Dim m_FileExtension As String
Dim m_ExtShortDescription As String
Dim m_ExtFullDescription As String
Dim m_ApplicationToRun As String
Dim m_ApplicationIconIndex As Integer






Private Sub CreateExtension(newfiletype As filetype)

Dim IconString As String
Dim Result As Long, Result2 As Long, ResultX As Long
Dim ReturnValue As Long, HKeyX As Long
Dim cmdloop As Integer

IconString = newfiletype.IconPath & "," & _
newfiletype.IconIndex

If Left$(newfiletype.Extension, 1) <> "." Then _
newfiletype.Extension = "." & newfiletype.Extension

RegCreateKey HKEY_CLASSES_ROOT, _
newfiletype.Extension, Result
ReturnValue = RegSetValueEx(Result, "", 0, REG_SZ, _
ByVal newfiletype.ProperName, _
LenB(StrConv(newfiletype.ProperName, vbFromUnicode)))

' Set up content type
If newfiletype.ContentType <> "" Then
ReturnValue = RegSetValueEx(Result, _
"Content Type", 0, REG_SZ, ByVal _
CStr(newfiletype.ContentType), _
LenB(StrConv(newfiletype.ContentType, vbFromUnicode)))
End If

RegCreateKey HKEY_CLASSES_ROOT, _
newfiletype.ProperName, Result

If Not IconString = ",0" Then
RegCreateKey Result, "DefaultIcon", _
Result2 'Create The Key of "ProperName\DefaultIcon"
ReturnValue = RegSetValueEx(Result2, _
"", 0, REG_SZ, ByVal IconString, _
LenB(StrConv(IconString, vbFromUnicode)))
'Set The Default Value for the Key
End If

ReturnValue = RegSetValueEx(Result, _
"", 0, REG_SZ, ByVal newfiletype.FullName, _
LenB(StrConv(newfiletype.FullName, vbFromUnicode)))
RegCreateKey Result, ByVal "Shell", ResultX

' Create neccessary subkeys for each command
For cmdloop = 1 To newfiletype.Commands.Captions.Count
RegCreateKey ResultX, ByVal _
newfiletype.Commands.Captions(cmdloop), Result
RegCreateKey Result, ByVal "Command", Result2
Dim CurrentCommand$
CurrentCommand = newfiletype.Commands.Commands(cmdloop)
ReturnValue = RegSetValueEx(Result2, _
"", 0, REG_SZ, ByVal CurrentCommand$, _
LenB(StrConv(CurrentCommand$, vbFromUnicode)))
RegCloseKey Result
RegCloseKey Result2
Next

RegCloseKey Result2
End Sub



Private Sub UserControl_Resize()
    mIM.Move 0, 0
    UserControl.Width = mIM.Width
    UserControl.Height = mIM.Height
End Sub


Public Sub RegisterNewFileType()
     
Dim myfiletype As filetype

myfiletype.ProperName = ExtShortDescription
myfiletype.FullName = ExtFullDescription
myfiletype.ContentType = FileContentType
If Left(FileExtension, 1) <> "." Then
    myfiletype.Extension = "." & FileExtension
Else
    myfiletype.Extension = FileExtension
End If
myfiletype.Commands.Captions.Add "Open"
myfiletype.Commands.Commands.Add ApplicationToRun & " %1"
myfiletype.IconPath = ApplicationToRun
myfiletype.IconIndex = ApplicationIconIndex

CreateExtension myfiletype
     
End Sub

Public Sub UnRegisterNewFileType()

Dim myfiletype As filetype

myfiletype.ProperName = ""
myfiletype.FullName = ""
myfiletype.ContentType = ""
If Left(FileExtension, 1) <> "." Then
    myfiletype.Extension = "." & FileExtension
Else
    myfiletype.Extension = FileExtension
End If
myfiletype.Commands.Captions.Add ""
myfiletype.Commands.Commands.Add ""
myfiletype.IconPath = ""
myfiletype.IconIndex = 0

CreateExtension myfiletype

End Sub

Public Property Get FileContentType() As String
Attribute FileContentType.VB_Description = "A string. Default is 'SomeMIMEtype'."
    FileContentType = m_FileContentType
End Property

Public Property Let FileContentType(ByVal New_FileContentType As String)
    m_FileContentType = New_FileContentType
    PropertyChanged "FileContentType"
End Property

Public Property Get FileExtension() As String
Attribute FileExtension.VB_Description = "A string. Any valid file extension."
    FileExtension = m_FileExtension
End Property

Public Property Let FileExtension(ByVal New_FileExtension As String)
    m_FileExtension = New_FileExtension
    PropertyChanged "FileExtension"
End Property

Public Property Get ExtShortDescription() As String
Attribute ExtShortDescription.VB_Description = "A string. A complete description for the new registered file type."
    ExtShortDescription = m_ExtShortDescription
End Property

Public Property Let ExtShortDescription(ByVal New_ExtShortDescription As String)
    m_ExtShortDescription = New_ExtShortDescription
    PropertyChanged "ExtShortDescription"
End Property

Public Property Get ExtFullDescription() As String
Attribute ExtFullDescription.VB_Description = "A string. A complete description for the new registered file type."
    ExtFullDescription = m_ExtFullDescription
End Property

Public Property Let ExtFullDescription(ByVal New_ExtFullDescription As String)
    m_ExtFullDescription = New_ExtFullDescription
    PropertyChanged "ExtFullDescription"
End Property

Public Property Get ApplicationToRun() As String
Attribute ApplicationToRun.VB_Description = "A string. This is the application (remember the full path!) to open the file to register. The application must open the first argument of the command line."
    ApplicationToRun = m_ApplicationToRun
End Property

Public Property Let ApplicationToRun(ByVal New_ApplicationToRun As String)
    m_ApplicationToRun = New_ApplicationToRun
    PropertyChanged "ApplicationToRun"
End Property

Public Property Get ApplicationIconIndex() As Integer
Attribute ApplicationIconIndex.VB_Description = "A number. Index of the icon to use to identify file fype. Default (0) means the first available icon in the executable. This is the icon you see browsing folders."
    ApplicationIconIndex = m_ApplicationIconIndex
End Property

Public Property Let ApplicationIconIndex(ByVal New_ApplicationIconIndex As Integer)
    m_ApplicationIconIndex = New_ApplicationIconIndex
    PropertyChanged "ApplicationIconIndex"
End Property

'Inizializza le propriet di UserControl
Private Sub UserControl_InitProperties()
    m_FileContentType = m_def_FileContentType
    m_FileExtension = m_def_FileExtension
    m_ExtShortDescription = m_def_ExtShortDescription
    m_ExtFullDescription = m_def_ExtFullDescription
    m_ApplicationToRun = m_def_ApplicationToRun
    m_ApplicationIconIndex = m_def_ApplicationIconIndex
End Sub

'Carica i valori della propriet dalla memoria
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    m_FileContentType = PropBag.ReadProperty("FileContentType", m_def_FileContentType)
    m_FileExtension = PropBag.ReadProperty("FileExtension", m_def_FileExtension)
    m_ExtShortDescription = PropBag.ReadProperty("ExtShortDescription", m_def_ExtShortDescription)
    m_ExtFullDescription = PropBag.ReadProperty("ExtFullDescription", m_def_ExtFullDescription)
    m_ApplicationToRun = PropBag.ReadProperty("ApplicationToRun", m_def_ApplicationToRun)
    m_ApplicationIconIndex = PropBag.ReadProperty("ApplicationIconIndex", m_def_ApplicationIconIndex)
End Sub

'Scrive i valori della propriet in memoria
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("FileContentType", m_FileContentType, m_def_FileContentType)
    Call PropBag.WriteProperty("FileExtension", m_FileExtension, m_def_FileExtension)
    Call PropBag.WriteProperty("ExtShortDescription", m_ExtShortDescription, m_def_ExtShortDescription)
    Call PropBag.WriteProperty("ExtFullDescription", m_ExtFullDescription, m_def_ExtFullDescription)
    Call PropBag.WriteProperty("ApplicationToRun", m_ApplicationToRun, m_def_ApplicationToRun)
    Call PropBag.WriteProperty("ApplicationIconIndex", m_ApplicationIconIndex, m_def_ApplicationIconIndex)
End Sub

