Attribute VB_Name = "prnDEFAULT"
Option Explicit

Private Declare Function WriteProfileString Lib "kernel32.dll" _
    Alias "WriteProfileStringA" (ByVal lpszSection As String, _
    ByVal lpszKeyName As String, ByVal lpszString As String) As Long
Private Declare Function SendNotifyMessage Lib "user32" _
    Alias "SendNotifyMessageA" (ByVal hwnd As Long, _
    ByVal msg As Long, ByVal wParam As Long, _
    ByVal lParam As Long) As Long
Private Declare Function SetDefaultPrinter Lib "winspool.drv" _
    Alias "SetDefaultPrinterA" (ByVal pszPrinter As String) As Boolean

Private Const WM_SETTINGCHANGE = &H1A
Private Const HWND_BROADCAST = &HFFFF&

Function impostaSTAMPANTE(nomeSTAMPANTE As String) As Boolean

    Dim l As Integer, A As String
    Dim Ret As Long

    impostaSTAMPANTE = False

    For l = 0 To Printers.Count - 1
        A = Printers(l).DeviceName
        If UCase(nomeSTAMPANTE) = UCase(A) Then
            'Debug.Print "nomeSTAMPANTE=|" & _
                        nomeSTAMPANTE & "|"
            Set Printer = Printers(l)
            Ret = WriteProfileString("Windows", "Device", nomeSTAMPANTE)
            SetDefaultPrinter nomeSTAMPANTE & Chr(0)
            Ret = SendNotifyMessage(HWND_BROADCAST, WM_SETTINGCHANGE, 0, 0)
            impostaSTAMPANTE = True
            Exit For
        End If
    Next l

End Function


