Attribute VB_Name = "CTooltipMOD"
Option Explicit

Private CTooltipLAST As Long
Private MyToolTip As CTooltipCLS

Public Sub ttCREATE(ttOBJ As Object, ttTEXT As String, Optional ttTITLE As String = "", Optional ttSHOWBALLOON As Boolean = True, Optional ttSHOWTITLE As Boolean = False, Optional ttSHOWINCENTER As Boolean = False, Optional ttFORECOLOR As Long = vbInfoText, Optional ttBACKCOLOR As Long = vbInfoBackground, Optional ttICON As Integer = 0)
    
' ttCREATE ttOBJ As Object, _                                  'must have HWnd !!
'          ttTEXT As String, _                                 'multiline tooltip text
'          Optional ttTITLE As String = "", _                  'balloon title
'          Optional ttSHOWBALLOON As Boolean = True, _         'show as rectangle or balloon
'          Optional ttSHOWTITLE As Boolean = False, _          'show title
'          Optional ttSHOWINCENTER As Boolean = False, _       'show in object center
'          Optional ttFORECOLOR As Long = vbInfoText, _        'tooltip forecolor
'          Optional ttBACKCOLOR As Long = vbInfoBackground), _ 'tooltip backcolor
'          Optional ttICON As integer = vbInfoBackground)      'icon pointer
                                                               'TTNoIcon = 0
                                                               'TTIconInfo = 1
                                                               'TTIconWarning = 2
                                                               'TTIconError = 3
    
    On Error GoTo createERROR

    If CTooltipLAST = ttOBJ.hWnd Then
        Exit Sub
    Else
        CTooltipLAST = ttOBJ.hWnd
    End If

    Set MyToolTip = Nothing
    Set MyToolTip = New CTooltipCLS

    With MyToolTip
        .HwndParentControl = ttOBJ.hWnd
        .Text = ttTEXT
        If ttSHOWBALLOON = True Then
            .Style = ttBALLOON
        Else
            .Style = TTStandard
        End If
        .Centered = ttSHOWINCENTER
        .BackColor = ttBACKCOLOR
        .ForeColor = ttFORECOLOR
        .Icon = ttICON
        If ttSHOWTITLE Then .Title = ttTITLE
        Call .Create
    End With
    
createEXIT:
    On Error Resume Next
    Err.Clear
    Exit Sub
    
createERROR:
    '
    MsgBox Err.Number & ": " & Err.Description, _
           vbCritical, _
           "TootTip Class - ttCREATE()"
    Resume createEXIT
    
End Sub




