Attribute VB_Name = "flatButtonzVRS"
Option Explicit

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type POINTAPI
    x As Long
    y As Long
End Type

Declare Function SetTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Attribute SetTimer.VB_MemberFlags = "40"
Declare Function ScreenToClient Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Attribute ScreenToClient.VB_MemberFlags = "40"
Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Attribute GetCursorPos.VB_MemberFlags = "40"
Declare Function KillTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long
Attribute KillTimer.VB_MemberFlags = "40"
Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Attribute GetClientRect.VB_MemberFlags = "40"

'This section is used to draw captions
Public Type DRAWTEXTPARAMS
    cbSize As Long
    iTabLength As Long
    iLeftMargin As Long
    iRightMargin As Long
    uiLengthDrawn As Long
End Type
Public Const DT_CALCRECT = &H400
Public Const DT_WORDBREAK = &H10
Public Const DT_VCENTER = &H4
Public Const DT_LEFT = &H0
Public Const DT_CENTER = &H1
Declare Function DrawTextEx Lib "user32" Alias "DrawTextExA" (ByVal hdc As Long, ByVal lpsz As String, ByVal n As Long, lpRect As RECT, ByVal un As Long, lpDrawTextParams As DRAWTEXTPARAMS) As Long
Attribute DrawTextEx.VB_MemberFlags = "40"
Declare Function GetLastError Lib "kernel32" () As Long
Attribute GetLastError.VB_MemberFlags = "40"

'This section is used to draw disabled captions and pictures
Public Const DST_BITMAP = &H4
Public Const DST_ICON = &H3
Public Const DST_PREFIXTEXT = &H2
Public Const DST_TEXT = &H1
Public Const DSS_DISABLED = &H20
Public Const DSS_MONO = &H80
Public Const DSS_NORMAL = &H0
Public Const DSS_RIGHT = &H8000
Public Const DSS_UNION = &H10
Declare Function DrawState Lib "user32" Alias "DrawStateA" (ByVal hdc As Long, ByVal hBrush As Long, ByVal lpDrawStateProc As Long, ByVal lParam As Long, ByVal wParam As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal n3 As Long, ByVal n4 As Long, ByVal un As Long) As Long
Attribute DrawState.VB_MemberFlags = "40"
Public Const SRCCOPY = &HCC0020
Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal XSrc As Long, ByVal YSrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Attribute StretchBlt.VB_MemberFlags = "40"

Declare Function BitBlt Lib "gdi32" (ByVal hDCDest As Long, ByVal XDest As Long, ByVal YDest As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hDCSrc As Long, ByVal XSrc As Long, ByVal YSrc As Long, ByVal dwRop As Long) As Long
Attribute BitBlt.VB_MemberFlags = "40"
Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, lpBits As Any) As Long
Attribute CreateBitmap.VB_MemberFlags = "40"
Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Attribute SetBkColor.VB_MemberFlags = "40"
Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Attribute SelectObject.VB_MemberFlags = "40"
Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Attribute CreateCompatibleBitmap.VB_MemberFlags = "40"
Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Attribute CreateCompatibleDC.VB_MemberFlags = "40"
Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Attribute DeleteDC.VB_MemberFlags = "40"
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Attribute DeleteObject.VB_MemberFlags = "40"

Public TimerFlag As Boolean
Attribute TimerFlag.VB_VarMemberFlags = "40"
Public mvarXButton As NmButton
Attribute mvarXButton.VB_VarMemberFlags = "40"

Public Sub TimerProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, ByVal dwTime As Long)
Attribute TimerProc.VB_MemberFlags = "40"
    Dim mvarPoint As POINTAPI
    Dim mvarClientRect As RECT

    If GetCursorPos(mvarPoint) Then
        If ScreenToClient(hwnd, mvarPoint) Then
            If GetClientRect(hwnd, mvarClientRect) Then
                If (mvarPoint.x < mvarClientRect.Left) Or (mvarPoint.x > mvarClientRect.Right) Or (mvarPoint.y < mvarClientRect.Top) Or (mvarPoint.y > mvarClientRect.Bottom) Then
                    If KillTimer(hwnd, 1) Then
                        TimerFlag = False
                        mvarXButton.PaintMe xbButtonFlat, 101 'Exit
                    End If
                End If
            End If
        End If
    End If
End Sub
